﻿namespace UltraGridInUltraGridCell
{
    using System;
    using System.Data;
    using System.Windows.Forms;
    using Infragistics.Win;
    using Infragistics.Win.UltraWinGrid;

    public partial class Form1 : Form
    {
        private Random rnd = new Random();

        public Form1()
        {
            this.InitializeComponent();
            this.Load += Form1_Load;
            this.ultraGridMain.InitializeLayout += UltraGridMain_InitializeLayout;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //  Add some data source to the main grid
            this.ultraGridMain.SetDataBinding(this.GetMainData(3), null);

            //  Set rendering and editing controls of UltraControlContainerEditor
            this.ultraControlContainerEditor1.EditingControl = this.ultraGridEditControl;
            this.ultraControlContainerEditor1.RenderingControl = this.ultraGridRenderControl;
            this.ultraControlContainerEditor1.EditingControlPropertyName = "DataSource";
            this.ultraControlContainerEditor1.RenderingControlPropertyName = "DataSource";

            //  Uncomment the next rows to hide the grids' captions.
            //  I intentionally left them to trace what happens when you put the grid in edit mode
            //this.ultraGridMain.DisplayLayout.CaptionVisible = DefaultableBoolean.False;
            //this.ultraGridEditControl.DisplayLayout.CaptionVisible = DefaultableBoolean.False;
            //this.ultraGridRenderControl.DisplayLayout.CaptionVisible = DefaultableBoolean.False;
        }

        private void UltraGridMain_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            //  Set the EditorComponent for the third column
            e.Layout.Bands[0].Columns["Col3"].EditorComponent = this.ultraControlContainerEditor1;

            //  Allow column and row sizing and set some acceptable height and width
            e.Layout.Override.AllowColSizing = AllowColSizing.Free;
            e.Layout.Bands[0].Columns["Col3"].Width = 200;
            e.Layout.Override.RowSizing = RowSizing.Free;
            e.Layout.Override.DefaultRowHeight = 120;
        }

        private DataTable GetMainData(int rows)
        {
            var dt = new DataTable();

            dt.Columns.Add("Col1", typeof(int));
            dt.Columns.Add("Col2", typeof(int));
            dt.Columns.Add("Col3", typeof(DataTable));

            for(int row = 0; row < rows; row++)
            {
                var rowTable = this.GetRowTable();
                dt.Rows.Add(new object[] { this.rnd.Next(100), this.rnd.Next(100), rowTable });
            }

            return dt;
        }

        private DataTable GetRowTable()
        {
            var dt = new DataTable();

            dt.Columns.Add("Col1", typeof(int));
            dt.Columns.Add("Col2", typeof(int));
            dt.Columns.Add("Col3", typeof(int));

            for(int row = 0; row < 3; row++)
            {
                dt.Rows.Add(new object[] { this.rnd.Next(100), this.rnd.Next(100), this.rnd.Next(100) });
            }

            return dt;
        }
    }
}
